
class Super extends Parser;
options {
    exportVocab=Super;
}

tokens {
    // Hack to have the scanner work with the sub parser, also.
    // The problem is one of build order:
    //   1. The super parser must be built
    //   2. The sub parser must be built (depends on several artifacts of the
    //      super grammar).
    //   3. The lexer is built (depends on token vocabularies from both
    //      parsers)
    "b";
}

{ 
    public static void main(String args[]) throws Exception {
        final Super parser = 
            new Super(new SuperLexer(System.in));
        parser.p();
    }
}

p       : (a)* EOF
        ;
a       : "a" 
        ;


class SuperLexer extends Lexer;

options {
//     charVocabulary='\u0000'..'\u007F';
    testLiterals = true; 
}

WS      : (' '
          | '\t'
          | 
          (options {generateAmbigWarnings=false;}
            : "\r\n"
            | '\r'
            | '\n'
            ) { newline(); })+
        {$setType(Token.SKIP);}
    ;  
PLUS    :	"+";
MINUS	:   "-";
NUMBER  : ('0' .. '9')+
        ;
OTHER   : ('(' | ')' | ';' | ('a' .. 'z')+)
        ;
